<?php

declare(strict_types=1);

use Phinx\Migration\AbstractMigration;

final class CreateProveedores extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change(): void
    {
        $this->table('proveedores', ['id' => false, 'primary_key' => ['rut', 'digito']])
            ->addColumn('rut', 'integer', ['identity' => true, 'signed' => false, 'null' => false])
            ->addColumn('digito', 'string', ['limit' => 1, 'null' => false])
            ->addColumn('nombre', 'string', ['limit' => 255, 'null' => false])
            ->addColumn('razon', 'string', ['limit' => 255, 'null' => true])
            ->addColumn('contacto_rut', 'integer', ['signed' => false, 'null' => true])
            ->addForeignKey('contacto_rut', 'personas', ['rut'], ['delete' => 'CASCADE', 'update' => 'CASCADE'])
            ->create();
    }
}
